/*
 * Copyright The Asahi Linux Contributors
 * SPDX-License-Identifier: MIT
 *
 * Autogenerated file, do not edit
 */

#include <stdint.h>

#pragma once
#include "util/macros.h"

struct libagx_decompress_args {
   uint64_t images;
   uint64_t metadata;
   uint64_t tile_uncompressed;
   uint32_t metadata_layer_stride_tl;
   uint16_t metadata_width_tl;
   uint16_t metadata_height_tl;
} PACKED;

static_assert(offsetof(struct libagx_decompress_args, images) == 0, "");
static_assert(offsetof(struct libagx_decompress_args, metadata) == 8, "");
static_assert(offsetof(struct libagx_decompress_args, tile_uncompressed) == 16, "");
static_assert(offsetof(struct libagx_decompress_args, metadata_layer_stride_tl) == 24, "");
static_assert(offsetof(struct libagx_decompress_args, metadata_width_tl) == 28, "");
static_assert(offsetof(struct libagx_decompress_args, metadata_height_tl) == 30, "");
static_assert(sizeof(struct libagx_decompress_args) == 32, "");

struct libagx_predicate_indirect_args {
   uint64_t out;
   uint64_t in;
   uint64_t draw_count;
   uint32_t stride_el;
} PACKED;

static_assert(offsetof(struct libagx_predicate_indirect_args, out) == 0, "");
static_assert(offsetof(struct libagx_predicate_indirect_args, in) == 8, "");
static_assert(offsetof(struct libagx_predicate_indirect_args, draw_count) == 16, "");
static_assert(offsetof(struct libagx_predicate_indirect_args, stride_el) == 24, "");
static_assert(sizeof(struct libagx_predicate_indirect_args) == 28, "");

struct libagx_increment_ia_args {
   uint64_t ia_vertices;
   uint64_t vs_invocations;
   uint64_t draw;
} PACKED;

static_assert(offsetof(struct libagx_increment_ia_args, ia_vertices) == 0, "");
static_assert(offsetof(struct libagx_increment_ia_args, vs_invocations) == 8, "");
static_assert(offsetof(struct libagx_increment_ia_args, draw) == 16, "");
static_assert(sizeof(struct libagx_increment_ia_args) == 24, "");

struct libagx_increment_ia_restart_args {
   uint64_t ia_vertices;
   uint64_t vs_invocations;
   uint64_t draw;
   uint64_t index_buffer;
   uint32_t index_buffer_range_el;
   uint32_t restart_index;
   uint32_t index_size_B;
} PACKED;

static_assert(offsetof(struct libagx_increment_ia_restart_args, ia_vertices) == 0, "");
static_assert(offsetof(struct libagx_increment_ia_restart_args, vs_invocations) == 8, "");
static_assert(offsetof(struct libagx_increment_ia_restart_args, draw) == 16, "");
static_assert(offsetof(struct libagx_increment_ia_restart_args, index_buffer) == 24, "");
static_assert(offsetof(struct libagx_increment_ia_restart_args, index_buffer_range_el) == 32, "");
static_assert(offsetof(struct libagx_increment_ia_restart_args, restart_index) == 36, "");
static_assert(offsetof(struct libagx_increment_ia_restart_args, index_size_B) == 40, "");
static_assert(sizeof(struct libagx_increment_ia_restart_args) == 44, "");

struct libagx_unroll_restart_args {
   uint64_t heap;
   uint64_t index_buffer;
   uint64_t in_draw;
   uint64_t out_draw;
   uint64_t zero_sink;
   uint32_t max_draws;
   uint32_t restart_index;
   uint32_t index_buffer_size_el;
   uint32_t flatshade_first;
} PACKED;

static_assert(offsetof(struct libagx_unroll_restart_args, heap) == 0, "");
static_assert(offsetof(struct libagx_unroll_restart_args, index_buffer) == 8, "");
static_assert(offsetof(struct libagx_unroll_restart_args, in_draw) == 16, "");
static_assert(offsetof(struct libagx_unroll_restart_args, out_draw) == 24, "");
static_assert(offsetof(struct libagx_unroll_restart_args, zero_sink) == 32, "");
static_assert(offsetof(struct libagx_unroll_restart_args, max_draws) == 40, "");
static_assert(offsetof(struct libagx_unroll_restart_args, restart_index) == 44, "");
static_assert(offsetof(struct libagx_unroll_restart_args, index_buffer_size_el) == 48, "");
static_assert(offsetof(struct libagx_unroll_restart_args, flatshade_first) == 52, "");
static_assert(sizeof(struct libagx_unroll_restart_args) == 56, "");

struct libagx_gs_setup_indirect_args {
   uint64_t index_buffer;
   uint64_t draw;
   uint64_t vertex_buffer;
   uint64_t ia;
   uint64_t p;
   uint64_t zero_sink;
   uint64_t vs_outputs;
   uint32_t index_size_B;
   uint32_t index_buffer_range_el;
   uint32_t prim;
} PACKED;

static_assert(offsetof(struct libagx_gs_setup_indirect_args, index_buffer) == 0, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, draw) == 8, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, vertex_buffer) == 16, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, ia) == 24, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, p) == 32, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, zero_sink) == 40, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, vs_outputs) == 48, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, index_size_B) == 56, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, index_buffer_range_el) == 60, "");
static_assert(offsetof(struct libagx_gs_setup_indirect_args, prim) == 64, "");
static_assert(sizeof(struct libagx_gs_setup_indirect_args) == 68, "");

struct libagx_prefix_sum_geom_args {
   uint64_t p;
} PACKED;

static_assert(offsetof(struct libagx_prefix_sum_geom_args, p) == 0, "");
static_assert(sizeof(struct libagx_prefix_sum_geom_args) == 8, "");

struct libagx_prefix_sum_tess_args {
   uint64_t p;
} PACKED;

static_assert(offsetof(struct libagx_prefix_sum_tess_args, p) == 0, "");
static_assert(sizeof(struct libagx_prefix_sum_tess_args) == 8, "");

struct libagx_copy_query_args {
   uint64_t availability;
   uint64_t results;
   uint64_t oq_index;
   uint64_t dst_addr;
   uint64_t dst_stride;
   uint32_t first_query;
   uint16_t partial;
   uint16_t _64;
   uint16_t with_availability;
   uint16_t reports_per_query;
} PACKED;

static_assert(offsetof(struct libagx_copy_query_args, availability) == 0, "");
static_assert(offsetof(struct libagx_copy_query_args, results) == 8, "");
static_assert(offsetof(struct libagx_copy_query_args, oq_index) == 16, "");
static_assert(offsetof(struct libagx_copy_query_args, dst_addr) == 24, "");
static_assert(offsetof(struct libagx_copy_query_args, dst_stride) == 32, "");
static_assert(offsetof(struct libagx_copy_query_args, first_query) == 40, "");
static_assert(offsetof(struct libagx_copy_query_args, partial) == 44, "");
static_assert(offsetof(struct libagx_copy_query_args, _64) == 46, "");
static_assert(offsetof(struct libagx_copy_query_args, with_availability) == 48, "");
static_assert(offsetof(struct libagx_copy_query_args, reports_per_query) == 50, "");
static_assert(sizeof(struct libagx_copy_query_args) == 52, "");

struct libagx_copy_query_gl_args {
   uint64_t query;
   uint64_t dest;
   uint16_t value_type;
   uint16_t bool_size;
} PACKED;

static_assert(offsetof(struct libagx_copy_query_gl_args, query) == 0, "");
static_assert(offsetof(struct libagx_copy_query_gl_args, dest) == 8, "");
static_assert(offsetof(struct libagx_copy_query_gl_args, value_type) == 16, "");
static_assert(offsetof(struct libagx_copy_query_gl_args, bool_size) == 18, "");
static_assert(sizeof(struct libagx_copy_query_gl_args) == 20, "");

struct libagx_copy_xfb_counters_args {
   uint64_t push;
} PACKED;

static_assert(offsetof(struct libagx_copy_xfb_counters_args, push) == 0, "");
static_assert(sizeof(struct libagx_copy_xfb_counters_args) == 8, "");

struct libagx_increment_statistic_args {
   uint64_t statistic;
   uint32_t delta;
} PACKED;

static_assert(offsetof(struct libagx_increment_statistic_args, statistic) == 0, "");
static_assert(offsetof(struct libagx_increment_statistic_args, delta) == 8, "");
static_assert(sizeof(struct libagx_increment_statistic_args) == 12, "");

struct libagx_increment_cs_invocations_args {
   uint64_t grid;
   uint64_t statistic;
   uint32_t local_size_threads;
} PACKED;

static_assert(offsetof(struct libagx_increment_cs_invocations_args, grid) == 0, "");
static_assert(offsetof(struct libagx_increment_cs_invocations_args, statistic) == 8, "");
static_assert(offsetof(struct libagx_increment_cs_invocations_args, local_size_threads) == 16, "");
static_assert(sizeof(struct libagx_increment_cs_invocations_args) == 20, "");

struct libagx_write_u32s_args {
   uint64_t p;
} PACKED;

static_assert(offsetof(struct libagx_write_u32s_args, p) == 0, "");
static_assert(sizeof(struct libagx_write_u32s_args) == 8, "");

struct libagx_copy_timestamp_args {
   uint64_t dest;
   uint64_t src;
} PACKED;

static_assert(offsetof(struct libagx_copy_timestamp_args, dest) == 0, "");
static_assert(offsetof(struct libagx_copy_timestamp_args, src) == 8, "");
static_assert(sizeof(struct libagx_copy_timestamp_args) == 16, "");

struct libagx_write_u32_args {
   uint64_t address;
   uint32_t value;
} PACKED;

static_assert(offsetof(struct libagx_write_u32_args, address) == 0, "");
static_assert(offsetof(struct libagx_write_u32_args, value) == 8, "");
static_assert(sizeof(struct libagx_write_u32_args) == 12, "");

struct libagx_tess_setup_indirect_args {
   uint64_t p;
   uint64_t grids;
   uint64_t ia;
   uint64_t indirect;
   uint64_t vertex_output_buffer_ptr;
   uint64_t in_index_buffer;
   uint32_t in_index_buffer_range_el;
   uint32_t in_index_size_B;
   uint64_t vertex_outputs;
   uint64_t tcs_statistic;
} PACKED;

static_assert(offsetof(struct libagx_tess_setup_indirect_args, p) == 0, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, grids) == 8, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, ia) == 16, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, indirect) == 24, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, vertex_output_buffer_ptr) == 32, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, in_index_buffer) == 40, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, in_index_buffer_range_el) == 48, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, in_index_size_B) == 52, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, vertex_outputs) == 56, "");
static_assert(offsetof(struct libagx_tess_setup_indirect_args, tcs_statistic) == 64, "");
static_assert(sizeof(struct libagx_tess_setup_indirect_args) == 72, "");

struct libagx_tess_isoline_args {
   uint64_t p;
} PACKED;

static_assert(offsetof(struct libagx_tess_isoline_args, p) == 0, "");
static_assert(sizeof(struct libagx_tess_isoline_args) == 8, "");

struct libagx_tess_tri_args {
   uint64_t p;
} PACKED;

static_assert(offsetof(struct libagx_tess_tri_args, p) == 0, "");
static_assert(sizeof(struct libagx_tess_tri_args) == 8, "");

struct libagx_tess_quad_args {
   uint64_t p;
} PACKED;

static_assert(offsetof(struct libagx_tess_quad_args, p) == 0, "");
static_assert(sizeof(struct libagx_tess_quad_args) == 8, "");

struct libagx_helper_args {
} PACKED;

static_assert(sizeof(struct libagx_helper_args) == 0, "");

enum libagx_program {
    LIBAGX_DECOMPRESS_0 = 0,
    LIBAGX_DECOMPRESS_1 = 1,
    LIBAGX_DECOMPRESS_2 = 2,
    LIBAGX_PREDICATE_INDIRECT_0 = 3,
    LIBAGX_PREDICATE_INDIRECT_1 = 4,
    LIBAGX_INCREMENT_IA = 5,
    LIBAGX_INCREMENT_IA_RESTART = 6,
    LIBAGX_UNROLL_RESTART_0 = 7,
    LIBAGX_UNROLL_RESTART_1 = 8,
    LIBAGX_UNROLL_RESTART_2 = 9,
    LIBAGX_UNROLL_RESTART_3 = 10,
    LIBAGX_UNROLL_RESTART_4 = 11,
    LIBAGX_UNROLL_RESTART_5 = 12,
    LIBAGX_UNROLL_RESTART_6 = 13,
    LIBAGX_UNROLL_RESTART_7 = 14,
    LIBAGX_UNROLL_RESTART_8 = 15,
    LIBAGX_UNROLL_RESTART_9 = 16,
    LIBAGX_UNROLL_RESTART_10 = 17,
    LIBAGX_UNROLL_RESTART_11 = 18,
    LIBAGX_UNROLL_RESTART_12 = 19,
    LIBAGX_UNROLL_RESTART_13 = 20,
    LIBAGX_UNROLL_RESTART_14 = 21,
    LIBAGX_UNROLL_RESTART_15 = 22,
    LIBAGX_UNROLL_RESTART_16 = 23,
    LIBAGX_UNROLL_RESTART_17 = 24,
    LIBAGX_UNROLL_RESTART_18 = 25,
    LIBAGX_UNROLL_RESTART_19 = 26,
    LIBAGX_UNROLL_RESTART_20 = 27,
    LIBAGX_UNROLL_RESTART_21 = 28,
    LIBAGX_UNROLL_RESTART_22 = 29,
    LIBAGX_UNROLL_RESTART_23 = 30,
    LIBAGX_UNROLL_RESTART_24 = 31,
    LIBAGX_UNROLL_RESTART_25 = 32,
    LIBAGX_UNROLL_RESTART_26 = 33,
    LIBAGX_UNROLL_RESTART_27 = 34,
    LIBAGX_UNROLL_RESTART_28 = 35,
    LIBAGX_UNROLL_RESTART_29 = 36,
    LIBAGX_UNROLL_RESTART_30 = 37,
    LIBAGX_UNROLL_RESTART_31 = 38,
    LIBAGX_UNROLL_RESTART_32 = 39,
    LIBAGX_GS_SETUP_INDIRECT = 40,
    LIBAGX_PREFIX_SUM_GEOM = 41,
    LIBAGX_PREFIX_SUM_TESS = 42,
    LIBAGX_COPY_QUERY = 43,
    LIBAGX_COPY_QUERY_GL = 44,
    LIBAGX_COPY_XFB_COUNTERS = 45,
    LIBAGX_INCREMENT_STATISTIC = 46,
    LIBAGX_INCREMENT_CS_INVOCATIONS = 47,
    LIBAGX_WRITE_U32S = 48,
    LIBAGX_COPY_TIMESTAMP = 49,
    LIBAGX_WRITE_U32 = 50,
    LIBAGX_TESS_SETUP_INDIRECT = 51,
    LIBAGX_TESS_ISOLINE_0 = 52,
    LIBAGX_TESS_ISOLINE_1 = 53,
    LIBAGX_TESS_TRI_0 = 54,
    LIBAGX_TESS_TRI_1 = 55,
    LIBAGX_TESS_QUAD_0 = 56,
    LIBAGX_TESS_QUAD_1 = 57,
    LIBAGX_HELPER = 58,
    LIBAGX_NUM_PROGRAMS,
};

static inline unsigned
LIBAGX_DECOMPRESS(unsigned log2_samples__3)
{
   assert(log2_samples__3 < 3);

   unsigned idx = log2_samples__3;

   assert(idx < 3);
   return LIBAGX_DECOMPRESS_0 + idx;
}

static inline unsigned
LIBAGX_PREDICATE_INDIRECT(unsigned indexed__2)
{
   assert(indexed__2 < 2);

   unsigned idx = indexed__2;

   assert(idx < 2);
   return LIBAGX_PREDICATE_INDIRECT_0 + idx;
}

static inline unsigned
LIBAGX_UNROLL_RESTART(unsigned index_size_log2__3, unsigned mode__11)
{
   assert(index_size_log2__3 < 3);
   assert(mode__11 < 11);

   unsigned idx = mode__11;
   idx = (idx * 3) + index_size_log2__3;

   assert(idx < 33);
   return LIBAGX_UNROLL_RESTART_0 + idx;
}

static inline unsigned
LIBAGX_TESS_ISOLINE(unsigned mode__2)
{
   assert(mode__2 < 2);

   unsigned idx = mode__2;

   assert(idx < 2);
   return LIBAGX_TESS_ISOLINE_0 + idx;
}

static inline unsigned
LIBAGX_TESS_TRI(unsigned mode__2)
{
   assert(mode__2 < 2);

   unsigned idx = mode__2;

   assert(idx < 2);
   return LIBAGX_TESS_TRI_0 + idx;
}

static inline unsigned
LIBAGX_TESS_QUAD(unsigned mode__2)
{
   assert(mode__2 < 2);

   unsigned idx = mode__2;

   assert(idx < 2);
   return LIBAGX_TESS_QUAD_0 + idx;
}


#define libagx_decompress_struct(_context, _grid, _data, log2_samples__3) do { \
   struct libagx_decompress_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_DECOMPRESS(log2_samples__3), &_args, sizeof(_args)); \
} while(0);

#define libagx_decompress(_context, _grid, images, metadata, tile_uncompressed, metadata_layer_stride_tl, metadata_width_tl, metadata_height_tl, log2_samples__3) do { \
   struct libagx_decompress_args _args = {images, metadata, tile_uncompressed, metadata_layer_stride_tl, metadata_width_tl, metadata_height_tl};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_DECOMPRESS(log2_samples__3), &_args, sizeof(_args)); \
} while(0);

#define libagx_predicate_indirect_struct(_context, _grid, _data, indexed__2) do { \
   struct libagx_predicate_indirect_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_PREDICATE_INDIRECT(indexed__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_predicate_indirect(_context, _grid, out, in, draw_count, stride_el, indexed__2) do { \
   struct libagx_predicate_indirect_args _args = {out, in, draw_count, stride_el};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_PREDICATE_INDIRECT(indexed__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_ia_struct(_context, _grid, _data) do { \
   struct libagx_increment_ia_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_IA, &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_ia(_context, _grid, ia_vertices, vs_invocations, draw) do { \
   struct libagx_increment_ia_args _args = {ia_vertices, vs_invocations, draw};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_IA, &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_ia_restart_struct(_context, _grid, _data) do { \
   struct libagx_increment_ia_restart_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_IA_RESTART, &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_ia_restart(_context, _grid, ia_vertices, vs_invocations, draw, index_buffer, index_buffer_range_el, restart_index, index_size_B) do { \
   struct libagx_increment_ia_restart_args _args = {ia_vertices, vs_invocations, draw, index_buffer, index_buffer_range_el, restart_index, index_size_B};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_IA_RESTART, &_args, sizeof(_args)); \
} while(0);

#define libagx_unroll_restart_struct(_context, _grid, _data, index_size_log2__3, mode__11) do { \
   struct libagx_unroll_restart_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_UNROLL_RESTART(index_size_log2__3, mode__11), &_args, sizeof(_args)); \
} while(0);

#define libagx_unroll_restart(_context, _grid, heap, index_buffer, in_draw, out_draw, zero_sink, max_draws, restart_index, index_buffer_size_el, index_size_log2__3, flatshade_first, mode__11) do { \
   struct libagx_unroll_restart_args _args = {heap, index_buffer, in_draw, out_draw, zero_sink, max_draws, restart_index, index_buffer_size_el, flatshade_first};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_UNROLL_RESTART(index_size_log2__3, mode__11), &_args, sizeof(_args)); \
} while(0);

#define libagx_gs_setup_indirect_struct(_context, _grid, _data) do { \
   struct libagx_gs_setup_indirect_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_GS_SETUP_INDIRECT, &_args, sizeof(_args)); \
} while(0);

#define libagx_gs_setup_indirect(_context, _grid, index_buffer, draw, vertex_buffer, ia, p, zero_sink, vs_outputs, index_size_B, index_buffer_range_el, prim) do { \
   struct libagx_gs_setup_indirect_args _args = {index_buffer, draw, vertex_buffer, ia, p, zero_sink, vs_outputs, index_size_B, index_buffer_range_el, prim};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_GS_SETUP_INDIRECT, &_args, sizeof(_args)); \
} while(0);

#define libagx_prefix_sum_geom_struct(_context, _grid, _data) do { \
   struct libagx_prefix_sum_geom_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_PREFIX_SUM_GEOM, &_args, sizeof(_args)); \
} while(0);

#define libagx_prefix_sum_geom(_context, _grid, p) do { \
   struct libagx_prefix_sum_geom_args _args = {p};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_PREFIX_SUM_GEOM, &_args, sizeof(_args)); \
} while(0);

#define libagx_prefix_sum_tess_struct(_context, _grid, _data) do { \
   struct libagx_prefix_sum_tess_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_PREFIX_SUM_TESS, &_args, sizeof(_args)); \
} while(0);

#define libagx_prefix_sum_tess(_context, _grid, p) do { \
   struct libagx_prefix_sum_tess_args _args = {p};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_PREFIX_SUM_TESS, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_query_struct(_context, _grid, _data) do { \
   struct libagx_copy_query_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_QUERY, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_query(_context, _grid, availability, results, oq_index, dst_addr, dst_stride, first_query, partial, _64, with_availability, reports_per_query) do { \
   struct libagx_copy_query_args _args = {availability, results, oq_index, dst_addr, dst_stride, first_query, partial, _64, with_availability, reports_per_query};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_QUERY, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_query_gl_struct(_context, _grid, _data) do { \
   struct libagx_copy_query_gl_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_QUERY_GL, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_query_gl(_context, _grid, query, dest, value_type, bool_size) do { \
   struct libagx_copy_query_gl_args _args = {query, dest, value_type, bool_size};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_QUERY_GL, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_xfb_counters_struct(_context, _grid, _data) do { \
   struct libagx_copy_xfb_counters_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_XFB_COUNTERS, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_xfb_counters(_context, _grid, push) do { \
   struct libagx_copy_xfb_counters_args _args = {push};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_XFB_COUNTERS, &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_statistic_struct(_context, _grid, _data) do { \
   struct libagx_increment_statistic_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_STATISTIC, &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_statistic(_context, _grid, statistic, delta) do { \
   struct libagx_increment_statistic_args _args = {statistic, delta};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_STATISTIC, &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_cs_invocations_struct(_context, _grid, _data) do { \
   struct libagx_increment_cs_invocations_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_CS_INVOCATIONS, &_args, sizeof(_args)); \
} while(0);

#define libagx_increment_cs_invocations(_context, _grid, grid, statistic, local_size_threads) do { \
   struct libagx_increment_cs_invocations_args _args = {grid, statistic, local_size_threads};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_INCREMENT_CS_INVOCATIONS, &_args, sizeof(_args)); \
} while(0);

#define libagx_write_u32s_struct(_context, _grid, _data) do { \
   struct libagx_write_u32s_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_WRITE_U32S, &_args, sizeof(_args)); \
} while(0);

#define libagx_write_u32s(_context, _grid, p) do { \
   struct libagx_write_u32s_args _args = {p};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_WRITE_U32S, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_timestamp_struct(_context, _grid, _data) do { \
   struct libagx_copy_timestamp_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_TIMESTAMP, &_args, sizeof(_args)); \
} while(0);

#define libagx_copy_timestamp(_context, _grid, dest, src) do { \
   struct libagx_copy_timestamp_args _args = {dest, src};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_COPY_TIMESTAMP, &_args, sizeof(_args)); \
} while(0);

#define libagx_write_u32_struct(_context, _grid, _data) do { \
   struct libagx_write_u32_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_WRITE_U32, &_args, sizeof(_args)); \
} while(0);

#define libagx_write_u32(_context, _grid, address, value) do { \
   struct libagx_write_u32_args _args = {address, value};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_WRITE_U32, &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_setup_indirect_struct(_context, _grid, _data) do { \
   struct libagx_tess_setup_indirect_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_SETUP_INDIRECT, &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_setup_indirect(_context, _grid, p, grids, ia, indirect, vertex_output_buffer_ptr, in_index_buffer, in_index_buffer_range_el, in_index_size_B, vertex_outputs, tcs_statistic) do { \
   struct libagx_tess_setup_indirect_args _args = {p, grids, ia, indirect, vertex_output_buffer_ptr, in_index_buffer, in_index_buffer_range_el, in_index_size_B, vertex_outputs, tcs_statistic};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_SETUP_INDIRECT, &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_isoline_struct(_context, _grid, _data, mode__2) do { \
   struct libagx_tess_isoline_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_ISOLINE(mode__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_isoline(_context, _grid, p, mode__2) do { \
   struct libagx_tess_isoline_args _args = {p};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_ISOLINE(mode__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_tri_struct(_context, _grid, _data, mode__2) do { \
   struct libagx_tess_tri_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_TRI(mode__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_tri(_context, _grid, p, mode__2) do { \
   struct libagx_tess_tri_args _args = {p};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_TRI(mode__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_quad_struct(_context, _grid, _data, mode__2) do { \
   struct libagx_tess_quad_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_QUAD(mode__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_tess_quad(_context, _grid, p, mode__2) do { \
   struct libagx_tess_quad_args _args = {p};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_TESS_QUAD(mode__2), &_args, sizeof(_args)); \
} while(0);

#define libagx_helper_struct(_context, _grid, _data) do { \
   struct libagx_helper_args _args = _data;\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_HELPER, &_args, sizeof(_args)); \
} while(0);

#define libagx_helper(_context, _grid) do { \
   struct libagx_helper_args _args = {};\
   MESA_DISPATCH_PRECOMP(_context, _grid, LIBAGX_HELPER, &_args, sizeof(_args)); \
} while(0);


extern const uint32_t *libagx_g13g[LIBAGX_NUM_PROGRAMS];
extern const uint32_t *libagx_g13x[LIBAGX_NUM_PROGRAMS];
extern const uint32_t libagx_0_nir[5112];
