/*
 * Copyright Mesa3D Contributors
 * SPDX-License-Identifier: MIT
 *
 * Autogenerated file, do not edit
 */
#pragma once
#include <stdint.h>
#include "compiler/nir/nir_builder.h"

static inline nir_def *
libagx_map_vertex_in_tri_strip(nir_builder *b, nir_def *prim, nir_def *vert, nir_def *flatshade_first)
{
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(flatshade_first->bit_size == 1);
   assert(flatshade_first->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_map_vertex_in_tri_strip");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_map_vertex_in_tri_strip");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "prim";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "vert";

      func->params[3].bit_size = 1;
      func->params[3].num_components = 1;
      func->params[3].name = "flatshade_first";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, prim, vert, flatshade_first);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_xfb_vertex_address(nir_builder *b, nir_def *p, nir_def *base_index, nir_def *vert, nir_def *buffer, nir_def *stride, nir_def *output_offset)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(base_index->bit_size == 32);
   assert(base_index->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(buffer->bit_size == 32);
   assert(buffer->num_components == 1);
   assert(stride->bit_size == 32);
   assert(stride->num_components == 1);
   assert(output_offset->bit_size == 32);
   assert(output_offset->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_xfb_vertex_address");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_xfb_vertex_address");
      func->num_params = 7;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "base_index";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vert";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "buffer";

      func->params[5].bit_size = 32;
      func->params[5].num_components = 1;
      func->params[5].name = "stride";

      func->params[6].bit_size = 32;
      func->params[6].num_components = 1;
      func->params[6].name = "output_offset";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, base_index, vert, buffer, stride, output_offset);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_vertex_id_for_line_loop(nir_builder *b, nir_def *prim, nir_def *vert, nir_def *num_prims)
{
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(num_prims->bit_size == 32);
   assert(num_prims->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_id_for_line_loop");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_id_for_line_loop");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "prim";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "vert";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "num_prims";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, prim, vert, num_prims);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_vertex_id_for_line_class(nir_builder *b, nir_def *mode, nir_def *prim, nir_def *vert, nir_def *num_prims)
{
   assert(mode->bit_size == 32);
   assert(mode->num_components == 1);
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(num_prims->bit_size == 32);
   assert(num_prims->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_id_for_line_class");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_id_for_line_class");
      func->num_params = 5;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "mode";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "prim";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vert";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "num_prims";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, mode, prim, vert, num_prims);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_vertex_id_for_tri_fan(nir_builder *b, nir_def *prim, nir_def *vert, nir_def *flatshade_first)
{
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(flatshade_first->bit_size == 1);
   assert(flatshade_first->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_id_for_tri_fan");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_id_for_tri_fan");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "prim";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "vert";

      func->params[3].bit_size = 1;
      func->params[3].num_components = 1;
      func->params[3].name = "flatshade_first";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, prim, vert, flatshade_first);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_vertex_id_for_tri_class(nir_builder *b, nir_def *mode, nir_def *prim, nir_def *vert, nir_def *flatshade_first)
{
   assert(mode->bit_size == 32);
   assert(mode->num_components == 1);
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(flatshade_first->bit_size == 1);
   assert(flatshade_first->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_id_for_tri_class");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_id_for_tri_class");
      func->num_params = 5;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "mode";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "prim";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vert";

      func->params[4].bit_size = 1;
      func->params[4].num_components = 1;
      func->params[4].name = "flatshade_first";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, mode, prim, vert, flatshade_first);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_vertex_id_for_line_adj_class(nir_builder *b, nir_def *mode, nir_def *prim, nir_def *vert)
{
   assert(mode->bit_size == 32);
   assert(mode->num_components == 1);
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_id_for_line_adj_class");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_id_for_line_adj_class");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "mode";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "prim";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vert";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, mode, prim, vert);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_vertex_id_for_tri_strip_adj(nir_builder *b, nir_def *prim, nir_def *vert, nir_def *num_prims, nir_def *flatshade_first)
{
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(num_prims->bit_size == 32);
   assert(num_prims->num_components == 1);
   assert(flatshade_first->bit_size == 1);
   assert(flatshade_first->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_id_for_tri_strip_adj");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_id_for_tri_strip_adj");
      func->num_params = 5;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "prim";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "vert";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "num_prims";

      func->params[4].bit_size = 1;
      func->params[4].num_components = 1;
      func->params[4].name = "flatshade_first";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, prim, vert, num_prims, flatshade_first);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_vertex_id_for_tri_adj_class(nir_builder *b, nir_def *mode, nir_def *prim, nir_def *vert, nir_def *nr, nir_def *flatshade_first)
{
   assert(mode->bit_size == 32);
   assert(mode->num_components == 1);
   assert(prim->bit_size == 32);
   assert(prim->num_components == 1);
   assert(vert->bit_size == 32);
   assert(vert->num_components == 1);
   assert(nr->bit_size == 32);
   assert(nr->num_components == 1);
   assert(flatshade_first->bit_size == 1);
   assert(flatshade_first->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_id_for_tri_adj_class");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_id_for_tri_adj_class");
      func->num_params = 6;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "mode";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "prim";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vert";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "nr";

      func->params[5].bit_size = 1;
      func->params[5].num_components = 1;
      func->params[5].name = "flatshade_first";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, mode, prim, vert, nr, flatshade_first);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_load_index_buffer(nir_builder *b, nir_def *p, nir_def *id, nir_def *index_size)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(id->bit_size == 32);
   assert(id->num_components == 1);
   assert(index_size->bit_size == 32);
   assert(index_size->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_load_index_buffer");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_load_index_buffer");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "id";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "index_size";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, id, index_size);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_setup_xfb_buffer(nir_builder *b, nir_def *p, nir_def *i)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(i->bit_size == 32);
   assert(i->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_setup_xfb_buffer");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_setup_xfb_buffer");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "i";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, i);

   return nir_load_deref(b, deref);
}

static inline void
libagx_end_primitive(nir_builder *b, nir_def *index_buffer, nir_def *total_verts, nir_def *verts_in_prim, nir_def *total_prims, nir_def *invocation_vertex_base, nir_def *invocation_prim_base, nir_def *geometry_base, nir_def *restart)
{
   assert(index_buffer->bit_size == 64);
   assert(index_buffer->num_components == 1);
   assert(total_verts->bit_size == 32);
   assert(total_verts->num_components == 1);
   assert(verts_in_prim->bit_size == 32);
   assert(verts_in_prim->num_components == 1);
   assert(total_prims->bit_size == 32);
   assert(total_prims->num_components == 1);
   assert(invocation_vertex_base->bit_size == 32);
   assert(invocation_vertex_base->num_components == 1);
   assert(invocation_prim_base->bit_size == 32);
   assert(invocation_prim_base->num_components == 1);
   assert(geometry_base->bit_size == 32);
   assert(geometry_base->num_components == 1);
   assert(restart->bit_size == 1);
   assert(restart->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_end_primitive");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_end_primitive");
      func->num_params = 8;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].name = "index_buffer";

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "total_verts";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "verts_in_prim";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "total_prims";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "invocation_vertex_base";

      func->params[5].bit_size = 32;
      func->params[5].num_components = 1;
      func->params[5].name = "invocation_prim_base";

      func->params[6].bit_size = 32;
      func->params[6].num_components = 1;
      func->params[6].name = "geometry_base";

      func->params[7].bit_size = 1;
      func->params[7].num_components = 1;
      func->params[7].name = "restart";
   }

   nir_call(b, func, index_buffer, total_verts, verts_in_prim, total_prims, invocation_vertex_base, invocation_prim_base, geometry_base, restart);
}

static inline void
libagx_build_gs_draw(nir_builder *b, nir_def *p, nir_def *vertices, nir_def *primitives)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(vertices->bit_size == 32);
   assert(vertices->num_components == 1);
   assert(primitives->bit_size == 32);
   assert(primitives->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_build_gs_draw");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_build_gs_draw");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].name = "p";

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "vertices";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "primitives";
   }

   nir_call(b, func, p, vertices, primitives);
}

static inline nir_def *
libagx_vertex_output_address(nir_builder *b, nir_def *buffer, nir_def *mask, nir_def *vtx, nir_def *location)
{
   assert(buffer->bit_size == 64);
   assert(buffer->num_components == 1);
   assert(mask->bit_size == 64);
   assert(mask->num_components == 1);
   assert(vtx->bit_size == 32);
   assert(vtx->num_components == 1);
   assert(location->bit_size == 32);
   assert(location->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_vertex_output_address");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_vertex_output_address");
      func->num_params = 5;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "buffer";

      func->params[2].bit_size = 64;
      func->params[2].num_components = 1;
      func->params[2].name = "mask";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vtx";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "location";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, buffer, mask, vtx, location);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_geometry_input_address(nir_builder *b, nir_def *p, nir_def *vtx, nir_def *location)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(vtx->bit_size == 32);
   assert(vtx->num_components == 1);
   assert(location->bit_size == 32);
   assert(location->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_geometry_input_address");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_geometry_input_address");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "vtx";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "location";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, vtx, location);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_input_vertices(nir_builder *b, nir_def *ia)
{
   assert(ia->bit_size == 64);
   assert(ia->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_input_vertices");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_input_vertices");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ia";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ia);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tcs_patch_vertices_in(nir_builder *b, nir_def *p)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tcs_patch_vertices_in");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tcs_patch_vertices_in");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tes_patch_vertices_in(nir_builder *b, nir_def *p)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tes_patch_vertices_in");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tes_patch_vertices_in");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tcs_unrolled_id(nir_builder *b, nir_def *p, nir_def *wg_id)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(wg_id->bit_size == 32);
   assert(wg_id->num_components == 3);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tcs_unrolled_id");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tcs_unrolled_id");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 3;
      func->params[2].name = "wg_id";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, wg_id);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tes_buffer(nir_builder *b, nir_def *p)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tes_buffer");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tes_buffer");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_load_tes_index(nir_builder *b, nir_def *p, nir_def *index)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(index->bit_size == 32);
   assert(index->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_load_tes_index");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_load_tes_index");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "index";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, index);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tcs_in_offset(nir_builder *b, nir_def *vtx, nir_def *location, nir_def *crosslane_vs_out_mask)
{
   assert(vtx->bit_size == 32);
   assert(vtx->num_components == 1);
   assert(location->bit_size == 32);
   assert(location->num_components == 1);
   assert(crosslane_vs_out_mask->bit_size == 64);
   assert(crosslane_vs_out_mask->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tcs_in_offset");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tcs_in_offset");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 32;
      func->params[1].num_components = 1;
      func->params[1].name = "vtx";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "location";

      func->params[3].bit_size = 64;
      func->params[3].num_components = 1;
      func->params[3].name = "crosslane_vs_out_mask";
   }

   const struct glsl_type *ret_type = glsl_vector_type(7, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, vtx, location, crosslane_vs_out_mask);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tcs_out_address(nir_builder *b, nir_def *p, nir_def *patch_id, nir_def *vtx_id, nir_def *location, nir_def *nr_patch_out, nir_def *out_patch_size, nir_def *vtx_out_mask)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(patch_id->bit_size == 32);
   assert(patch_id->num_components == 1);
   assert(vtx_id->bit_size == 32);
   assert(vtx_id->num_components == 1);
   assert(location->bit_size == 32);
   assert(location->num_components == 1);
   assert(nr_patch_out->bit_size == 32);
   assert(nr_patch_out->num_components == 1);
   assert(out_patch_size->bit_size == 32);
   assert(out_patch_size->num_components == 1);
   assert(vtx_out_mask->bit_size == 64);
   assert(vtx_out_mask->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tcs_out_address");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tcs_out_address");
      func->num_params = 8;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "patch_id";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vtx_id";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "location";

      func->params[5].bit_size = 32;
      func->params[5].num_components = 1;
      func->params[5].name = "nr_patch_out";

      func->params[6].bit_size = 32;
      func->params[6].num_components = 1;
      func->params[6].name = "out_patch_size";

      func->params[7].bit_size = 64;
      func->params[7].num_components = 1;
      func->params[7].name = "vtx_out_mask";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, patch_id, vtx_id, location, nr_patch_out, out_patch_size, vtx_out_mask);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tes_patch_id(nir_builder *b, nir_def *p, nir_def *raw_id)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(raw_id->bit_size == 32);
   assert(raw_id->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tes_patch_id");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tes_patch_id");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "raw_id";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, raw_id);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_load_tess_coord(nir_builder *b, nir_def *p, nir_def *raw_id)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(raw_id->bit_size == 32);
   assert(raw_id->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_load_tess_coord");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_load_tess_coord");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "raw_id";
   }

   const struct glsl_type *ret_type = glsl_vector_type(2, 2);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, raw_id);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tes_in_address(nir_builder *b, nir_def *p, nir_def *raw_id, nir_def *vtx_id, nir_def *location)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);
   assert(raw_id->bit_size == 32);
   assert(raw_id->num_components == 1);
   assert(vtx_id->bit_size == 32);
   assert(vtx_id->num_components == 1);
   assert(location->bit_size == 32);
   assert(location->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tes_in_address");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tes_in_address");
      func->num_params = 5;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "raw_id";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "vtx_id";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "location";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p, raw_id, vtx_id, location);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tess_level_outer_default(nir_builder *b, nir_def *p)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tess_level_outer_default");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tess_level_outer_default");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";
   }

   const struct glsl_type *ret_type = glsl_vector_type(2, 4);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_tess_level_inner_default(nir_builder *b, nir_def *p)
{
   assert(p->bit_size == 64);
   assert(p->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_tess_level_inner_default");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_tess_level_inner_default");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "p";
   }

   const struct glsl_type *ret_type = glsl_vector_type(2, 2);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, p);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_txs(nir_builder *b, nir_def *ptr, nir_def *lod, nir_def *nr_comps, nir_def *is_buffer, nir_def *is_1d, nir_def *is_2d, nir_def *is_cube, nir_def *is_array)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);
   assert(lod->bit_size == 16);
   assert(lod->num_components == 1);
   assert(nr_comps->bit_size == 32);
   assert(nr_comps->num_components == 1);
   assert(is_buffer->bit_size == 1);
   assert(is_buffer->num_components == 1);
   assert(is_1d->bit_size == 1);
   assert(is_1d->num_components == 1);
   assert(is_2d->bit_size == 1);
   assert(is_2d->num_components == 1);
   assert(is_cube->bit_size == 1);
   assert(is_cube->num_components == 1);
   assert(is_array->bit_size == 1);
   assert(is_array->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_txs");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_txs");
      func->num_params = 9;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";

      func->params[2].bit_size = 16;
      func->params[2].num_components = 1;
      func->params[2].name = "lod";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "nr_comps";

      func->params[4].bit_size = 1;
      func->params[4].num_components = 1;
      func->params[4].name = "is_buffer";

      func->params[5].bit_size = 1;
      func->params[5].num_components = 1;
      func->params[5].name = "is_1d";

      func->params[6].bit_size = 1;
      func->params[6].num_components = 1;
      func->params[6].name = "is_2d";

      func->params[7].bit_size = 1;
      func->params[7].num_components = 1;
      func->params[7].name = "is_cube";

      func->params[8].bit_size = 1;
      func->params[8].num_components = 1;
      func->params[8].name = "is_array";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 4);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr, lod, nr_comps, is_buffer, is_1d, is_2d, is_cube, is_array);

   return nir_trim_vector(b, nir_load_deref(b, deref), 3);
}

static inline nir_def *
libagx_texture_samples(nir_builder *b, nir_def *ptr)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_texture_samples");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_texture_samples");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_texture_levels(nir_builder *b, nir_def *ptr)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_texture_levels");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_texture_levels");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_lower_txf_robustness(nir_builder *b, nir_def *ptr, nir_def *check_lod, nir_def *lod, nir_def *check_layer, nir_def *layer, nir_def *x)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);
   assert(check_lod->bit_size == 1);
   assert(check_lod->num_components == 1);
   assert(lod->bit_size == 16);
   assert(lod->num_components == 1);
   assert(check_layer->bit_size == 1);
   assert(check_layer->num_components == 1);
   assert(layer->bit_size == 32);
   assert(layer->num_components == 1);
   assert(x->bit_size == 32);
   assert(x->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_lower_txf_robustness");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_lower_txf_robustness");
      func->num_params = 7;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";

      func->params[2].bit_size = 1;
      func->params[2].num_components = 1;
      func->params[2].name = "check_lod";

      func->params[3].bit_size = 16;
      func->params[3].num_components = 1;
      func->params[3].name = "lod";

      func->params[4].bit_size = 1;
      func->params[4].num_components = 1;
      func->params[4].name = "check_layer";

      func->params[5].bit_size = 32;
      func->params[5].num_components = 1;
      func->params[5].name = "layer";

      func->params[6].bit_size = 32;
      func->params[6].num_components = 1;
      func->params[6].name = "x";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr, check_lod, lod, check_layer, layer, x);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_image_texel_address(nir_builder *b, nir_def *ptr, nir_def *coord, nir_def *sample_idx, nir_def *bytes_per_sample_B, nir_def *is_1d, nir_def *is_msaa, nir_def *is_layered, nir_def *return_index)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);
   assert(coord->bit_size == 32);
   assert(coord->num_components == 4);
   assert(sample_idx->bit_size == 32);
   assert(sample_idx->num_components == 1);
   assert(bytes_per_sample_B->bit_size == 32);
   assert(bytes_per_sample_B->num_components == 1);
   assert(is_1d->bit_size == 1);
   assert(is_1d->num_components == 1);
   assert(is_msaa->bit_size == 1);
   assert(is_msaa->num_components == 1);
   assert(is_layered->bit_size == 1);
   assert(is_layered->num_components == 1);
   assert(return_index->bit_size == 1);
   assert(return_index->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_image_texel_address");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_image_texel_address");
      func->num_params = 9;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 4;
      func->params[2].name = "coord";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "sample_idx";

      func->params[4].bit_size = 32;
      func->params[4].num_components = 1;
      func->params[4].name = "bytes_per_sample_B";

      func->params[5].bit_size = 1;
      func->params[5].num_components = 1;
      func->params[5].name = "is_1d";

      func->params[6].bit_size = 1;
      func->params[6].num_components = 1;
      func->params[6].name = "is_msaa";

      func->params[7].bit_size = 1;
      func->params[7].num_components = 1;
      func->params[7].name = "is_layered";

      func->params[8].bit_size = 1;
      func->params[8].num_components = 1;
      func->params[8].name = "return_index";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr, coord, sample_idx, bytes_per_sample_B, is_1d, is_msaa, is_layered, return_index);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_buffer_texel_address(nir_builder *b, nir_def *ptr, nir_def *coord, nir_def *bytes_per_pixel_B)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);
   assert(coord->bit_size == 32);
   assert(coord->num_components == 4);
   assert(bytes_per_pixel_B->bit_size == 32);
   assert(bytes_per_pixel_B->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_buffer_texel_address");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_buffer_texel_address");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 4;
      func->params[2].name = "coord";

      func->params[3].bit_size = 32;
      func->params[3].num_components = 1;
      func->params[3].name = "bytes_per_pixel_B";
   }

   const struct glsl_type *ret_type = glsl_vector_type(9, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr, coord, bytes_per_pixel_B);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_texture_is_rgb32(nir_builder *b, nir_def *ptr)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_texture_is_rgb32");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_texture_is_rgb32");
      func->num_params = 2;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";
   }

   const struct glsl_type *ret_type = glsl_vector_type(11, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_texture_load_rgb32(nir_builder *b, nir_def *ptr, nir_def *coord, nir_def *is_float)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);
   assert(coord->bit_size == 32);
   assert(coord->num_components == 1);
   assert(is_float->bit_size == 1);
   assert(is_float->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_texture_load_rgb32");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_texture_load_rgb32");
      func->num_params = 4;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "coord";

      func->params[3].bit_size = 1;
      func->params[3].num_components = 1;
      func->params[3].name = "is_float";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 4);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr, coord, is_float);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_buffer_texture_offset(nir_builder *b, nir_def *ptr, nir_def *x)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);
   assert(x->bit_size == 32);
   assert(x->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_buffer_texture_offset");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_buffer_texture_offset");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "x";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr, x);

   return nir_load_deref(b, deref);
}

static inline nir_def *
libagx_buffer_image_offset(nir_builder *b, nir_def *ptr, nir_def *x)
{
   assert(ptr->bit_size == 64);
   assert(ptr->num_components == 1);
   assert(x->bit_size == 32);
   assert(x->num_components == 1);

   nir_function *func = nir_shader_get_function_for_name(b->shader, "libagx_buffer_image_offset");

   if (!func) {
      func = nir_function_create(b->shader, "libagx_buffer_image_offset");
      func->num_params = 3;
      func->params = rzalloc_array(b->shader, nir_parameter, func->num_params);

      func->params[0].bit_size = 64;
      func->params[0].num_components = 1;
      func->params[0].is_return = true;

      func->params[1].bit_size = 64;
      func->params[1].num_components = 1;
      func->params[1].name = "ptr";

      func->params[2].bit_size = 32;
      func->params[2].num_components = 1;
      func->params[2].name = "x";
   }

   const struct glsl_type *ret_type = glsl_vector_type(0, 1);
   nir_variable *ret = nir_local_variable_create(b->impl, ret_type, "return");
   nir_deref_instr *deref = nir_build_deref_var(b, ret);
   deref->def.bit_size = 64;

   nir_call(b, func, &deref->def, ptr, x);

   return nir_load_deref(b, deref);
}

